unit Sample5_main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  _MNOglExTools, ExtCtrls, _MnOglCanvas, _MNComTypes, _MNdevice, ComCtrls,
  _MNOglTools, StdCtrls;

type
  TForm1 = class(TForm)
    MNOglControl1: TMNOglControl;
    Splitter1: TSplitter;
    Panel1: TPanel;
    MNOglNav1: TMNOglNav;
    MnOglCanvas1: TMnOglCanvas;
    MNOglScene1: TMNOglScene;
    StatusBar1: TStatusBar;
    MNOglSphere1: TMNOglSphere;
    MNOglBox1: TMNOglBox;
    MNOglLight1: TMNOglLight;
    MnOglSequencer1: TMnOglSequencer;
    MnOglTimer1: TMnOglTimer;
    Panel2: TPanel;
    Memo1: TMemo;
    RadioGroup1: TRadioGroup;
    procedure MnOglSequencer1Timer(Sender: TObject);
    procedure MnOglTimer1timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MNOglBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MNOglSphere1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MNOglControl1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
    glbHitsSphere, glbHitsBox:integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses
  _Mnmath;

{$R *.DFM}

procedure TForm1.MnOglSequencer1Timer(Sender: TObject);
begin
  // must be assigned BUT can be empty ...
end;

procedure TForm1.MnOglTimer1timer(Sender: TObject);
VAR
  i, j : integer;
begin
  i := Random (5);
  j := Random (5);
  If i mod 2 = 0 then begin
    i := -i;
    j := -j;
  end;
  with MNOglSphere1 do begin
    Translation := NewPt (i,j,0);
  end;
  with MNOglBox1 do begin
    Translation := NewPt (j,i,0);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Randomize;
  glbHitsSphere := 0;
  glbHitsBox := 0;
end;

procedure TForm1.MNOglBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
VAR
  mat : TMaterialKind;
begin
  If RadioGroup1.ItemIndex <> 1 then begin
    Inc (glbHitsBox);
    with MNOglBox1 do begin
      mat := Attributes.Material.Kind;
      If Mat.EMISSION = clRed then
        Mat.EMISSION := clNavy
      else
        Mat.EMISSION := clRed;
      Attributes.Material.Kind := mat;
    end;
    Panel2.Caption := 'Hits: ' + IntToStr (glbHitsBox) + ' / ' + IntToStr (glbHitsSphere);
  end;
end;

procedure TForm1.MNOglSphere1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
VAR
  mat : TMaterialKind;
begin
  If RadioGroup1.ItemIndex <> 1 then begin
    Inc (glbHitsSphere);
    with MNOglSphere1 do begin
      mat := Attributes.Material.Kind;
      If Mat.EMISSION = clGreen then
        Mat.EMISSION := clYellow
      else
        Mat.EMISSION := clGreen;
      Attributes.Material.Kind := mat;
    end;
    Panel2.Caption := 'Hits: ' + IntToStr (glbHitsBox) + ' / ' + IntToStr (glbHitsSphere);
  end;
end;

procedure TForm1.MNOglControl1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
VAR
  HI : THitItem;
  aShape:TCustomShape;
  mat : TMaterialKind;
begin
  If RadioGroup1.ItemIndex = 1 then begin
    If MNOglCanvas1.Select (x, y) then begin
      If MNOglCanvas1.Hits.Count > 0 then begin
        HI := THitItem (MNOglCanvas1.Hits[0]);
        try
          aShape := TCustomShape (HI.Tag);
          If aShape is TMNOglBox then begin
            mat := aShape.Attributes.Material.Kind;
            Inc (glbHitsBox);
            If Mat.EMISSION = clRed then
              Mat.EMISSION := clNavy
            else
              Mat.EMISSION := clRed;
            aShape.Attributes.Material.Kind := mat;
          end
          else If aShape is TMNOglSphere then begin
            mat := aShape.Attributes.Material.Kind;
            Inc (glbHitsSphere);
            If Mat.EMISSION = clGreen then
              Mat.EMISSION := clYellow
            else
              Mat.EMISSION := clGreen;
            aShape.Attributes.Material.Kind := mat;
          end;
          Panel2.Caption := 'Hits: ' + IntToStr (glbHitsBox) + ' / ' + IntToStr (glbHitsSphere);
        except
        end;
      end;
    end;
  end;
end;

end.
